<template>
  <!-- <div @click="testHandler">测试</div> -->
  <!-- <div>
    <template v-for="(x,i) in FeatureImg">
      <img :src="x.url" alt="" style="width: 80px;">
    </template>
  </div> -->
  <!-- <div>
    <img :src="item" v-for="item in datas.FeatureImgList"  style="width: 80px;" />
  </div> -->
  <div class="editor-header">
    <div class="left">
      <div class="menu-item" v-tooltip="'去首页'" @click="goBack()">首页</div>
      <Popover trigger="click" placement="bottom-start" v-model:value="mainMenuVisible">
        <template #content>
          <FileInput accept=".pptist"  @change="files => {
            importSpecificFile(files)
            mainMenuVisible = false
          }">
            <PopoverMenuItem>导入 pptist 文件</PopoverMenuItem>
          </FileInput>
          <FileInput accept="application/vnd.openxmlformats-officedocument.presentationml.presentation"  @change="files => {
            importPPTXFile(files)
            mainMenuVisible = false
          }">
            <PopoverMenuItem>导入 pptx 文件（测试版）</PopoverMenuItem>
          </FileInput>
          <PopoverMenuItem @click="setDialogForExport('pptx')">导出文件</PopoverMenuItem>
          <PopoverMenuItem @click="resetSlides(); mainMenuVisible = false">重置幻灯片</PopoverMenuItem>
          <!-- <PopoverMenuItem @click="goLink('https://github.com/pipipi-pikachu/PPTist/issues')">意见反馈</PopoverMenuItem>
          <PopoverMenuItem @click="goLink('https://github.com/pipipi-pikachu/PPTist/blob/master/doc/Q&A.md')">常见问题</PopoverMenuItem> -->
          <PopoverMenuItem @click="mainMenuVisible = false; hotkeyDrawerVisible = true">快捷键</PopoverMenuItem>
        </template>
        <div class="menu-item"><IconHamburgerButton class="icon" /></div>
      </Popover>

      <div class="title">
        <Input 
          class="title-input" 
          ref="titleInputRef"
          v-model:value="queryObj.Title" 
          @blur="handleUpdateTitle()" 
          v-if="editingTitle" 
        ></Input>
        <div 
          class="title-text"
          @click="startEditTitle()"
          :title="queryObj.Title"
          v-else
        >{{ queryObj.Title }}</div>
      </div>
    </div>

    <div class="right">
      <!-- <div class="group-menu-item">
        <div class="menu-item" v-tooltip="'幻灯片放映'" @click="enterScreening()">
          <IconPpt class="icon" />
        </div>
        <Popover trigger="click" center>
          <template #content>
            <PopoverMenuItem @click="enterScreeningFromStart()">从头开始</PopoverMenuItem>
            <PopoverMenuItem @click="enterScreening()">从当前页开始</PopoverMenuItem>
          </template>
          <div class="arrow-btn"><IconDown class="arrow" /></div>
        </Popover>
      </div> -->
      <div class="group-menu-item" v-if="userInfo.IsEditTripTemplate==1&&model">
        <div class="menu-item" v-tooltip="'导入PSD'" @click="UploadPsdHandler">
          <IconUpload class="icon" />
        </div>
      </div>
      <div class="menu-item" v-tooltip="'导出'" @click="setDialogForExport('pptx')">
        <IconDownload class="icon" />
      </div>
      <!-- <el-button type="danger" v-tooltip="'保存'" 
      size="small" icon="Check" circle :loading="datas.loading"
      @click="setTemplate()" style="color: #ffff;"></el-button> setTemplate()-->
      <el-button type="danger" 
      v-if="(userInfo.IsEditTripTemplate==1&&model)||ConfigId>0"
      size="small" :loading="datas.loading"
      @click="setTemplate" style="color: #ffff;margin-left: 10px;">
        <template v-if="userInfo.IsEditTripTemplate==1&&model">
         保存模板
        </template>
        <template v-if="ConfigId>0">
          保存行程
        </template>
    </el-button>
    <div>
    </div>
      <!-- <a class="github-link" href="https://github.com/pipipi-pikachu/PPTist" target="_blank">
        <div class="menu-item"><IconGithub class="icon" /></div>
      </a> -->
    </div>

    <Drawer
      :width="320"
      v-model:visible="hotkeyDrawerVisible"
      placement="right"
    >
      <HotkeyDoc />
    </Drawer>

    <FullscreenSpin :loading="exporting" tip="正在导入..." />
    <Psd-Upload :visible="psdVisibleStatus" @closed="psdVisibleStatus=false"></Psd-Upload>
  </div>
  <div v-if="ConfigId" style="opacity: 0;position: absolute;left: 100px;top: 0;bottom: 0;overflow: auto;z-index: -1;">
    <div class="export-img-dialog">
      <div class="thumbnails-view">
        <div class="thumbnails" v-for="slide in slides" ref="FeatureImgRef">
          <ThumbnailSlide 
            class="thumbnail" 
            :key="slide.id" 
            :slide="slide" 
            :size="viewportRatio==0.7069?1754:1240" 
          />
        </div>
      </div>
    </div>
  </div>
  
</template>

<script lang="ts" setup>
import { nextTick, ref, reactive, inject, computed, watch } from 'vue'
import { storeToRefs } from 'pinia'
import { toPng, toJpeg } from 'html-to-image'
import message from '@/utils/message'
import { useMainStore, useSlidesStore } from '@/store'
import useScreening from '@/hooks/useScreening'
import useImport from '@/hooks/useImport'
import useSlideHandler from '@/hooks/useSlideHandler'
import type { DialogForExportTypes } from '@/types/export'
import { userStore } from "@/store/user";
import { useScreenStore } from "@/store/screen";
import ConfigService from '@/services/ConfigService'
import { injectKeyDataSource, injectKeyTemplate } from '@/types/injectKey'
import PsdUpload from '@/components/PSD/Index.vue'
import { svg2Base64 } from '@/utils/svg2Base64'
import UploadService from '@/services/UploadService'
import { domainManager } from '@/utils/domainManager'
import { ToolbarStates } from '@/types/toolbar'
import useEditor from '@/utils/Editor/index'
import useExport from '@/hooks/useExport'


import HotkeyDoc from './HotkeyDoc.vue'
import FileInput from '@/components/FileInput.vue'
import FullscreenSpin from '@/components/FullscreenSpin.vue'
import Drawer from '@/components/Drawer.vue'
import Input from '@/components/Input.vue'
import Popover from '@/components/Popover.vue'
import PopoverMenuItem from '@/components/PopoverMenuItem.vue'
import { PPTImageElement } from '@/types/slides'
import AliyunUpload from '@/utils/upload/aliyun'
import { ElLoading, ElMessage } from 'element-plus'
import ThumbnailSlide from '@/views/components/ThumbnailSlide/index.vue'


const mainStore = useMainStore()
const slidesStore = useSlidesStore()
const layoutsStore = useSlidesStore()
const { title, slides, slideIndex, viewportRatio } = storeToRefs(slidesStore)
const { enterScreening, enterScreeningFromStart } = useScreening()
const { importSpecificFile, importPPTXFile, exporting } = useImport()
const { resetSlides } = useSlideHandler()

const imageThumbnailsRef = ref<HTMLElement>()
const mainMenuVisible = ref(false)
const hotkeyDrawerVisible = ref(false)
const editingTitle = ref(false)
const titleInputRef = ref<InstanceType<typeof Input>>()
const titleValue = ref('')
const { setNewDatasList } = useEditor()


const { userInfo } = storeToRefs(userStore())

const datas = reactive({
  FeatureImgList:[],
  DataSource:{},
  loading: false
})
datas.FeatureImgList = inject(injectKeyDataSource).FeatureImgList
const queryObj = ref({} as any)
const searchData = ref({} as any)
datas.DataSource = inject(injectKeyDataSource)
queryObj.value = inject(injectKeyDataSource).queryObj
searchData.value = inject(injectKeyTemplate)
const marketStore = useScreenStore()
const CoverImgStore = useScreenStore()
const dataLoadingStore = useScreenStore()
const TempIdStore = useScreenStore()
const FeatureImgStore = useScreenStore()
const ConfigIdStore = useScreenStore()
const FeatureImgRef = ref(null)
const FeatureImgList = ref(null)

const { exportFeatureImg } = useExport()

const psdVisibleStatus = ref(false)
const { market, model, ConfigId, CoverImg, dataLoading, TempId, FeatureImg, SourceLoading } = storeToRefs(useScreenStore())

// 返回到首页
const goBack = () =>{
  let list = [
    {
      id: 'test-slide-1',
      pageType: 1,
      elements: [],
      background: {
        type: 'solid',
        color: '#ffffff',
      },
    }
  ]
  if(model.value) {
    searchData.value.TempId = 0
    marketStore.setMarket(true)
    slidesStore.setSlides(list)
    layoutsStore.setLayouts([])
    CoverImgStore.setCoverImg(null)
    return
  }
  ElMessageBox.confirm(
    '退出此页面将清空当前数据，请谨慎操作?',
    '提示',
    {
      confirmButtonText: '确定',
      cancelButtonText: '取消',
      type: 'warning',
    }
  ).then(() => {
    searchData.value.TempId = 0
    marketStore.setMarket(true)
    slidesStore.setSlides(list)
    layoutsStore.setLayouts([])
    CoverImgStore.setCoverImg(null)
  }).catch(() => {})
  
}
// 导入PSD
const UploadPsdHandler = () => {
  psdVisibleStatus.value = true
}

// 新增修改模版
const SetTripTemplateSlide = async () => {
  try {
    let TemplateRes = await ConfigService.SetTripTemplateSlide(queryObj.value);
    if (TemplateRes.data.resultCode == 1) {
      if(!queryObj.value.TempId){
        queryObj.value.TempId = TemplateRes.data.data.TempId
        searchData.value.TempId = TemplateRes.data.data.TempId
      }
      ElMessage({
        showClose: true,
        message: '操作成功',
        type: 'success',
      })
      datas.DataSource.DataSourceOverlay = false
      dataLoadingStore.setDataLoading(1)
    }else{
      ElMessage({
        showClose: true,
        message: '操作失败',
        type: 'warning',
      })
    }
  } catch (error) {}
  datas.loading = false
}

const uploadImageHandler = async ()=>{
  let count = 0
  let index = 0
  const instance = ElLoading.service({
    text:'收集需要处理的图片'
  })
  for (let i = 0; i < slides.value.length; i++) {
    const slide = slides.value[i];
    if(slide.elements){
      count += (slide.elements.filter(x => "src" in x && x.src && x.src.startsWith("data:image")) ?? []).length
    }
  }

  if(count>0){
    for (let i = 0; i < slides.value.length; i++) {
      const slide = slides.value[i];
      if(slide.elements){
        let temp = slide.elements.filter(x => "src" in x && x.src.startsWith("data:image")) ?? []
        for(let j = 0; j < temp.length; j++){
          index++
          instance.text.value = `当前图片处理进度：${index} / ${count}`
          const item = temp[j] as PPTImageElement

          let name = new Date().getTime()+".png"
          const file = dataURLtoFile(item.src, name)
          let url = await AliyunUpload.UploadAsync(file,`pptist/desgin/${name}`)
          url.then(res=>{
            if(res) {
              item.src = res
              const props = { src: res }
              slidesStore.updateElement({ id: item.id, props, slideId:slide.id })
            }
          })
        }
      }
    }
  }
   
  instance.close()
}

const dataURLtoFile = (dataurl:string, filename:string) => {
  let arr = dataurl.split(",")
  let mime = arr[0].match(/:(.*?);/)[1],
  bstr = atob(arr[1]),
  n = bstr.length,
  u8arr = new Uint8Array(n);
  while (n--) {
    u8arr[n] = bstr.charCodeAt(n);
  }
  return new File([u8arr], filename, { type: mime });
}

// 用户新增修改数据
const SetTripTemplateConfig = async () => {
    try {
      let queryMsg = {
        ConfigId: ConfigId.value,
        TempId: queryObj.value.TempId,
        TempData: queryObj.value.TempData,
        FeatureImg: datas.FeatureImgList
      }
        let TemplateRes = await ConfigService.SetSetTripConfig(queryMsg);
        if (TemplateRes.data.resultCode == 1) {
          if(!ConfigId.value){
            ConfigIdStore.value = TemplateRes.data.data.ConfigId
          }
          ElMessage({
            showClose: true,
            message: '操作成功',
            type: 'success',
          })
          window.parent.postMessage('行程数据保存成功', `${domainManager().notificationUrl}`);
          dataLoadingStore.setDataLoading(2)
        }else{
          ElMessage({
            showClose: true,
            message: '操作失败',
            type: 'warning',
          })
        }
    } catch (error) {}
    FeatureImgStore.setFeatureImg([])
    datas.loading = false
 
}
// 保存
const setTemplate = async () =>{
  datas.loading = true
  if(SourceLoading.value) setNewDatasList(datas.DataSource)

  await uploadImageHandler()
  let arr = JSON.parse(JSON.stringify(slides.value))
  if(dataLoading.value){
    dataLoadingStore.setDataLoading(0)
  }
  // console.log(JSON.stringify(slides.value),'----保存接口',queryObj.value)
  if(model.value&&userInfo.value.IsEditTripTemplate==1){
    arr.forEach(x=>{
      x.elements.forEach(y=>{
        delete y.TemplateList
      })
    })
    if(CoverImg&&CoverImg.value) queryObj.value.CoverImg = CoverImg.value
    else {
      datas.loading = false
      mainStore.setToolbarState(ToolbarStates.EL_TEMPLATEDATA)
        return ElMessage({
          showClose: true,
          message: '请生成封面图',
          type: 'warning',
      })
    }
    if(queryObj.value.Title==''||!queryObj.value.LineId||queryObj.value.LineName==''
    ||queryObj.value.CoverImg==''
    ||queryObj.value.CountryName==''||queryObj.value.SeasonName==''
    ){
      datas.loading = false
      mainStore.setToolbarState(ToolbarStates.EL_TEMPLATEDATA)
      return ElMessage({
        showClose: true,
        message: '请完善右侧模版数据',
        type: 'warning',
      })
    }
  } else {
    arr.forEach(x=>{
      x.elements.forEach(y=>{
        delete y.TemplateList
        delete y.TemplateDataSource
      })
    })
  }
  for(let i=0;i<slides.value.length;i++){
    if(slides.value[i].elements.length==0) {
        datas.loading = false
        mainStore.setToolbarState(ToolbarStates.EL_TEMPLATEDATA)
        return ElMessage({
            showClose: true,
            message: `请设计 第 ${i+1} 页 的数据`,
            type: 'warning',
          })
      }
  }
  // console.log(arr,'-------tttt')
  
  queryObj.value.TempData = JSON.stringify(arr)
  
  if(model.value&&userInfo.value.IsEditTripTemplate==1){
    await SetTripTemplateSlide()
  }
  if(ConfigId.value){
    await testHandler()
  }
}

// 行程图生成bes64图
const testHandler = async ()=>{
  FeatureImgStore.setFeatureImg([])
  if(FeatureImgRef.value&&FeatureImgRef.value.length>0){
    for (let i = 0; i < FeatureImgRef.value.length; i++) {
      let result = await exportFeatureImg(FeatureImgRef.value[i], 'jpeg', 1, false, i)
      if(!result){
        // console.log('异常')
        // datas.loading = false
        // break
      }
    }
    setFeatureImgList()
  }
}

// 行程图上传
const setFeatureImgList = async () => {
  datas.FeatureImgList = []
  FeatureImgList.value = []
  if(FeatureImg.value&&FeatureImg.value.length>0){
    for (let i = 0; i < FeatureImg.value.length; i++) {
      let name = new Date().getTime()+".jpg"
      const file = dataURLtoFile(FeatureImg.value[i].url, name)
      let result = AliyunUpload.UploadAsync(file,`Feature/${ConfigId.value}_${i}`)
      result.then(res=>{
        if(res) {
          let path = res.split('_')
          FeatureImgList.value.push({
            index: path[1],
            url: res
          })
          if(i==FeatureImg.value.length-1) {
            setTimeout(()=>{
                let list = FeatureImgList.value.sort((a,b)=>{
                  return a.index-b.index
                })
                datas.FeatureImgList = list.map(x=>{return x.url})
                SetTripTemplateConfig()
            },400)
          }
        }
      })
    }
  }
  // try {
  //     let queryObj = {
  //       MyFile: url
  //     }
  //     let path = `?fileType=1&fileLimit=5&&filePath=Feature/${ConfigId.value}_`
  //     let Res = await UploadService.UploadBase64Two(path,queryObj);
  //     if (Res.data&&Res.data.FilePath) {
  //       datas.FeatureImgList.push(`${domainManager().ViittoFileUrl}/${Res.data.FilePath}`)
  //       if(datas.FeatureImgList.length==slides.value.length){
  //         await SetTripTemplateConfig()
  //       }
  //     }
  // } catch (error) {
  //   datas.loading = false
  //   ElMessage({
  //     showClose: true,
  //     message: '上传行程文件出错',
  //     type: 'warning',
  //   })
  // }
}

const startEditTitle = () => {
  titleValue.value = title.value
  editingTitle.value = true
  nextTick(() => titleInputRef.value?.focus())
}

const handleUpdateTitle = () => {
  slidesStore.setTitle(titleValue.value)
  editingTitle.value = false
}

const goLink = (url: string) => {
  window.open(url)
  mainMenuVisible.value = false
}

const setDialogForExport = (type: DialogForExportTypes) => {
  mainStore.setDialogForExport(type)
  mainMenuVisible.value = false
}
</script>

<style lang="scss" scoped>
.export-img-dialog {
  height: 100%;
  display: flex;
  justify-content: center;
  align-items: center;
  flex-direction: column;
  position: relative;
  overflow: hidden;
}
.thumbnails-view {
  @include absolute-0();

  &::after {
    content: '';
    background-color: #fff;
    @include absolute-0();
  }
}
.configs {
  width: 350px;
  height: calc(100% - 100px);
  display: flex;
  flex-direction: column;
  justify-content: center;
  z-index: 1;

  .row {
    display: flex;
    justify-content: center;
    align-items: center;
    margin-bottom: 25px;
  }

  .title {
    width: 100px;
    position: relative;

    &::after {
      content: attr(data-range);
      position: absolute;
      top: 20px;
      left: 0;
    }
  }
  .config-item {
    flex: 1;
  }
}
.btns {
  width: 300px;
  height: 100px;
  display: flex;
  justify-content: center;
  align-items: center;
  z-index: 1;

  .export {
    flex: 1;
  }
  .close {
    width: 100px;
    margin-left: 10px;
  }
}
.editor-header {
  background-color: #fff;
  user-select: none;
  border-bottom: 1px solid $borderColor;
  display: flex;
  justify-content: space-between;
  padding: 0 5px;
}
.left, .right {
  display: flex;
  justify-content: center;
  align-items: center;
}
.menu-item {
  height: 30px;
  display: flex;
  justify-content: center;
  align-items: center;
  font-size: 14px;
  padding: 0 10px;
  border-radius: $borderRadius;
  cursor: pointer;

  .icon {
    font-size: 18px;
    color: #666;
  }

  &:hover {
    background-color: #f1f1f1;
  }
}
.group-menu-item {
  height: 30px;
  display: flex;
  margin: 0 8px;
  padding: 0 2px;
  border-radius: $borderRadius;

  &:hover {
    background-color: #f1f1f1;
  }

  .menu-item {
    padding: 0 3px;
  }
  .arrow-btn {
    display: flex;
    justify-content: center;
    align-items: center;
    cursor: pointer;
  }
}
.title {
  height: 32px;
  margin-left: 2px;
  font-size: 13px;

  .title-input {
    width: 200px;
    height: 100%;
    padding-left: 0;
    padding-right: 0;
  }
  .title-text {
    min-width: 20px;
    max-width: 400px;
    line-height: 32px;
    padding: 0 6px;
    border-radius: $borderRadius;
    cursor: pointer;

    @include ellipsis-oneline();

    &:hover {
      background-color: #f1f1f1;
    }
  }
}
.github-link {
  display: inline-block;
  height: 30px;
}
</style>